#!/bin/bash
PKCMD="./pk3cmd.sh -V4 -P12F683"

if [ $# -lt 2 ] || [ "$1" == "--help" ] || [ "$1" == "-h" ]; then
    echo "Usage: $0 [FRAMEWARE] [DEVICE_ID]" 
    exit
fi

if [ ! -f "pk3cmd.sh" ]; then
    echo "Nie odnaleziono pk3cmd.bat!"
    exit
fi

if [ $2 -ge 16000 ]; then
    echo "Device ID musi być mniejsze niż 16 tys.!!!"
    exit
fi

# Prepare ID File
# ID File Example: (06 00 00 0A)
# :08400000 0600 0000 0000 0A00 A8
# :00000001FF
FullID=$2
LoID=$((FullID & 0xFF))
HiID=$((FullID >> 8))
CSUM=$((71 + $1 + $LoID + $HiID))
CTRL=$((~ CSUM & 0xFF))
IDHEX=`printf ":08400000%02X0000000000%02X%02X%02X" "$1" "$LoID" "$HiID" "$CTRL" 2> /dev/null`
printf "$IDHEX\n:00000001FF\n" > id.hex

printf "Write ID... "
$PKCMD "-Fid.hex" -MI #> /dev/null
RETVAL=$?
if [ $RETVAL -ne 0 ]; then
    printf "\nProblem z ustawieniem ID X%02X0000%02X\n" $1 $2
    exit
fi

# Stop if no args
[ $# -gt 2 ] && exit

printf "Read ID... "
$PKCMD "-GFdump.hex" #> /dev/null
RETVAL=$?
if [ $RETVAL -ne 0 ]; then
    printf "\nProblem z ustawieniem ID X%02X0000%02X\n" $1 $2
    exit
fi

printf "Check ID... "
RETVAL=$(grep $IDHEX dump.hex)
echo "$RETVAL"
